package de.timpt.x2h;

/*
This file is part of PJava.

PJava is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PJava is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

import javax.swing.*;
import javax.swing.text.*;

/**
 * Extends the JTextArea for specialized needs.
 * @author Marcel Paggen 
 */

public class PJTextArea extends JTextArea{
  private static final long serialVersionUID = -6597757658514929496L;
  
  // TODO implement other constructors
  

  /**
   * Constructs a new TextArea
   */
  public PJTextArea(){
    super();
  }
  
  /**
   * Constructs a new TextArea with a specified initial text
   * @param text initial text 
   */
  public PJTextArea(String text){
    super(text);
  }
  
  /**
   * Constructs a new PJTextArea
   * @param text text to display
   * @param rows the number of rows
   * @param columns the number of columns
   */
  public PJTextArea(String text, int rows, int columns){
    super(text,rows,columns);
  }
  
  /**
   * Constructor
   * @param rows the number of rows
   * @param columns the number of columns
   */
  public PJTextArea(int rows, int columns){
    super(rows,columns);
  }
  
  /**
   * Constructor
   * @param doc the document to use
   * @param text initial text
   * @param rowas the number of rows
   * @param columns the number of columns
   */
  public PJTextArea(Document doc, String text, int rows, int columns){
    super(doc,text,rows,columns);
  }
  
  /**
   * Constructor
   * @param doc the document to use
   */
  public PJTextArea(Document doc){
    super(doc);
  }
  
  /**
   * Returns the String of a line from a JTextArea
   * @param index index of the line
   * @return String of the line
   * @throws BadLocationException 
   */
  public String getLineString(int index) throws BadLocationException{
    int startIndex = getLineStartOffset(index),
        endIndex = getLineEndOffset(index);
    if (endIndex <= startIndex) return "";
    return getText().substring(startIndex,endIndex);
  }
}
