package de.timpt.x2h;

/*
This file is part of PJava.

PJava is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PJava is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

public class ScalaKeywords {
  private final String[] keywords ={"abstract","case","catch","class",
      "def","do","else","extends","false","final","finally","for",
      "forSome","if","implicit","import","lazy","match","new","null",
      "object","override","package","private","protected","requires",
      "return","sealed","super","this","throw","trait","try","true",
      "type","val","var","while","with","yield","_",":","=","=>","<-",
      "<:","<%",">:","#","@","\u21D2","\u2190"}; 

  /**
   * checks if a String is a keyword in Scala
   * @param s the String to check
   * @return is a keyword in Scala?
   */
  public boolean isKeyword(String s){
    for (String key: keywords) if (s.trim().equals(key)) return true;
    return false;
  }

}
