package de.timpt.x2h;

/*
This file is part of PJava.

PJava is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PJava is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.awt.event.*;

import javax.swing.event.*;


/**
 * Main control class for X2H
 */
public class X2HMainControl{
  private X2HMainView view;           // The main view of X2H
  private X2HConverter converter;     // The converter
 
  
  /**
   * Constructor
   */
  protected X2HMainControl(){
    view = new X2HMainView();
    converter = new X2HConverter(view);
    createListener();
  }
  
  /**
   * Creates the Listener
   */
  private void createListener(){
    view.addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent e){
        System.exit(0);
      }
    });
    
    DocumentListener dcl = new DocumentListener() {
      @Override
      public void changedUpdate(DocumentEvent arg0){
        startConversion();        
      }

      @Override
      public void insertUpdate(DocumentEvent arg0){
        startConversion();
      }

      @Override
      public void removeUpdate(DocumentEvent arg0){
        startConversion();
      }                  
    };
    
    view.progLanguage.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        startConversion();
      }
    });
    view.sourceTextArea.getDocument().addDocumentListener(dcl);
    view.backgroundColor.getDocument().addDocumentListener(dcl);
  }
  
  /**
   * Starts the conversion
   */
  private void startConversion(){
    converter.doConversion();
  }
}
